unit hiBitBtnSwitch;

interface

uses Windows,Kol,Share,Win,messages;

{$I share.inc}

type
  THIBitBtnSwitch = class(THIWin)
   private
     FBmp:PBitmap;
     FX,FY:integer;

     procedure SetCaption(const Value:string);
     procedure SetBitmap(Value:HBITMAP);
     procedure SetFlat(Value:boolean);
     function _OnDraw( Sender: PControl; BtnState: Integer ): Boolean;
     procedure _OnClick(Obj:PObj);
     //function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; //override;
   public
     _event_onClick:THI_Event;
     _event_onPushButton:THI_Event;
     _prop_Data:TData;
     _prop_Frame:byte;
     _prop_FrameColor:TColor;
     _prop_SplitFon:byte;
     _prop_DrawFrame:byte;
     _prop_UnDrawFrame:byte;
     _prop_Invalidate:byte;

     _prop_ColorHover:integer;
     _prop_Cursor:integer;
     _prop_Underline:boolean;

    constructor Create(Parent:PControl);

    procedure _work_doCaption(var _Data:TData; Index:word);
    procedure _work_doColor(var _Data:TData; Index:word);
    property _prop_Caption:string write SetCaption;
    property _prop_Bitmap:HBITMAP write SetBitmap;
    property _prop_Flat:boolean write SetFlat;
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doPush(var _Data:TData; Index:word);

  end;

implementation

constructor THIBitBtnSwitch.Create;
begin
   inherited Create(Parent);

   FBmp := NewBitmap(0,0);
   Control := NewBitBtn(Parent,'BitBtn',[],glyphLeft,0,0);
   Control.TextShiftX := 1;
   Control.TextShiftY := 1;
   //Control.Style := Control.Style and not WS_BORDER;
   Control.OnBitBtnDraw := _OnDraw;
   //Control.Flat := true;
   Control.OnClick := _OnClick;
   //Control.Transparent := true;
   //Control.ExStyle := Control.ExStyle or WS_EX_TRANSPARENT;
   //Control.BitBtnImgList
end;
{
function THIBitBtnSwitch._onMessage;
var ps:TPaintStruct;
begin
   case Msg.message of
     WM_PAINT:
      begin
        BeginPaint(Control.Handle,ps);
        //Rectangle(ps.hdc,0,0,Control.Width,Control.Height);
        Result := false;
        EndPaint(Control.Handle,ps);
      end;
     else Result := inherited _onMessage(Msg,Rslt);
   end;
end;
}
procedure THIBitBtnSwitch._OnClick;
var dt:TData;
begin
   dt := _prop_Data;
   _hi_OnEvent(_event_onClick,dt);
end;

function THIBitBtnSwitch._OnDraw;
var r:TRect;
  procedure Fill;
  begin
   // if Control.Flat = false then
     with Control.Canvas{$ifndef F_P}^{$endif} do
      begin
       Brush.BrushStyle := bsSolid;
       Brush.Color := Control.Color;
       FillRect(r);
      end;
  end;
begin
   r := Control.ClientRect;
   Result := true;
   with Control.Canvas{$ifndef F_P}^{$endif} do
    case BtnState of
     0,2,3:     

{--------------  ----------------}

        begin //normal;

          Fill;
          if Control.Flat then
           begin
            Pen.PenStyle := psSolid;
            Brush.BrushStyle := bsClear;
            if _prop_Frame = 0 then
             Pen.PenStyle := psSolid
            else Pen.PenStyle := psClear;
            //Pen.Color := _prop_FrameColor;
            //Rectangle(0,0,Control.Width,Control.Height);
           end
              else
            DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX-0,FY-0);
          r.Left := -2;
          r.Top := -2;

          if not Control.Enabled then
           begin
             Font.Color := clWindow;
             inc(r.Top); inc(r.Left);
             inc(r.Bottom); inc(r.Right);
             DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
             dec(r.Top);  dec(r.Left);
             dec(r.Bottom); dec(r.Right);
             Font.Color := clBtnShadow;
           end
        //else Font.Color := _prop_Font.Color;
    else        
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
      
   if _prop_ColorHover <> 0 then
     Control.Font.Color := _prop_Font.Color; 
   if _prop_Cursor <> 0 then
      Control.Cursor := crDefault;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle - [fsUnderline];




if _prop_UnDrawFrame = 0 then
          Pen.Color := clBtnHighlight;
if _prop_UnDrawFrame = 0 then
          MoveTo(0,Control.Height-1);
if _prop_UnDrawFrame = 0 then
          LineTo(0,0);
if _prop_UnDrawFrame = 0 then
          LineTo(Control.Width-1,0);
if _prop_UnDrawFrame = 0 then
          Pen.Color := clBtnShadow;
if _prop_UnDrawFrame = 0 then
          LineTo(Control.Width-1,Control.Height-1);
if _prop_UnDrawFrame = 0 then
          LineTo(0,Control.Height-1)
   else

if _prop_UnDrawFrame = 2 then
          Pen.Color := clBtnShadow;
if _prop_UnDrawFrame = 2 then
          MoveTo(0,Control.Height-1);
if _prop_UnDrawFrame = 2 then
          LineTo(0,0);
if _prop_UnDrawFrame = 2 then
          LineTo(Control.Width-1,0);
if _prop_UnDrawFrame = 2 then
          Pen.Color := clBtnHighlight;
if _prop_UnDrawFrame = 2 then
          LineTo(Control.Width-1,Control.Height-1);
if _prop_UnDrawFrame = 2 then
          LineTo(0,Control.Height-1);

          //TextOut(25,Control.Height div 2 - 4,Control.Caption);
        end;
     40:
        begin
          Pen.Color := clActiveCaption;
          Fill;

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
          //TextOut(5,Control.Height div 2 - 4,Control.Caption);
        end;

{------------------- ---------------------}

     1:
        begin // down
          Fill;
 
          if Control.Flat then
           DrawEdge(Handle,r,BDR_SUNKENOUTER,BF_RECT)
          else
            DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT or DFCS_PUSHED);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);
             
    _hi_OnEvent(_event_onPushButton);
        end;

{---------------- ----------------}

     4:
        begin // select

          Fill;
          if Control.Flat then
            DrawEdge(Handle,r,BDR_RAISEDINNER,BF_RECT)
          else DrawFrameControl(Handle, r, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_TRANSPARENT);

          dec(r.Left,2); dec(r.top,2);
                             
          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX-0,FY-0);

          Brush.BrushStyle := bsClear;
          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);

   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_ColorHover;
   if _prop_Cursor <> 0 then
      Control.Cursor := _prop_Cursor;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle + [fsUnderline];

if _prop_DrawFrame = 1 then
          Pen.Color := clBtnHighlight;
if _prop_DrawFrame = 1 then
          MoveTo(0,Control.Height-1);
if _prop_DrawFrame = 1 then
          LineTo(0,0);
if _prop_DrawFrame = 1 then
          LineTo(Control.Width-1,0);
if _prop_DrawFrame = 1 then
          Pen.Color := clBtnShadow;
if _prop_DrawFrame = 1 then
          LineTo(Control.Width-1,Control.Height-1);
if _prop_DrawFrame = 1 then
          LineTo(0,Control.Height-1)
else 
if _prop_DrawFrame = 2 then
          Pen.Color := clBtnShadow;
if _prop_DrawFrame = 2 then
          MoveTo(0,Control.Height-1);
if _prop_DrawFrame = 2 then
          LineTo(0,0);
if _prop_DrawFrame = 2 then
          LineTo(Control.Width-1,0);
if _prop_DrawFrame = 2 then
          Pen.Color := clBtnHighlight;
if _prop_DrawFrame = 2 then
          LineTo(Control.Width-1,Control.Height-1);
if _prop_DrawFrame = 2 then
          LineTo(0,Control.Height-1);

        end;
     //else _debug(int2str(BtnState));
    end;
end;

procedure THIBitBtnSwitch._work_doCaption;
begin
   Control.Caption := ReadString(_data,null,'');
end;

procedure THIBitBtnSwitch._work_doColor;
begin
  Control.Color := ToInteger(_Data);
end;

procedure THIBitBtnSwitch.SetCaption;
begin
   Control.Caption := Value;
end;

procedure THIBitBtnSwitch.SetBitmap;
var c:TColor;
   i,j:word;
begin
   FBmp.Handle := Value;

   if FBmp.Width = 0 then exit;
   c := FBmp.Pixels[0,0];
   for i := 0 to FBmp.Width-1 do
    for j := 0 to FBmp.Height-1 do

 //    if FBmp.Pixels[i,j] = c then
 //     FBmp.Pixels[i,j] := clBtnFace;

     if FBmp.Pixels[i,j] = c then
          if _prop_SplitFon = 1 then
             FBmp.Pixels[i,j] := TColor(_prop_Color)
  else FBmp.Pixels[i,j] := clBtnFace;

   FY := _prop_Height div 2 - FBmp.Height div 2;
   if Control.Caption = '' then
       FX := _prop_Width div 2 - FBmp.Width div 2
   else FX := 0;  //   
end;

procedure THIBitBtnSwitch.SetFlat;
begin
   Control.Flat := Value;
end;

procedure THIBitBtnSwitch._work_doLoad;  
var c:TColor;
     i,j:word;
begin
      
      FBmp.Assign(PBitmap(_Data.idata));
       if _prop_Invalidate = 0 then
     Control.Invalidate; 
      if FBmp.Width = 0 then exit;

   c := FBmp.Pixels[0,0];
     for i := 0 to FBmp.Width-1 do
    for j := 0 to FBmp.Height-1 do
     if FBmp.Pixels[i,j] = c then
          if _prop_SplitFon = 0 then
             FBmp.Pixels[i,j]
  else FBmp.Pixels[i,j] := TColor(_prop_Color);
 
FY := _prop_Height div 2 - FBmp.Height div 2;
   if Control.Caption = '' then
       FX := _prop_Width div 2 - FBmp.Width div 2
      else FX := 0; //     

end;

procedure THIBitBtnSwitch._work_doPush;
var r:TRect;
begin
r := Control.ClientRect;
with Control.Canvas^ do
begin
     _prop_UnDrawFrame:= ToInteger(_data);

Brush.BrushStyle := bsSolid;
          Brush.Color := Control.Color;
          Rectangle(0,0,Control.Width,Control.Height);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY); 

          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);

if _prop_UnDrawFrame = 0 then
          Pen.Color := clBtnShadow
else    Pen.Color := clBtnHighlight;
          MoveTo(0,Control.Height-1);
          LineTo(0,0);
          LineTo(Control.Width-1,0);
if _prop_UnDrawFrame = 0 then
          Pen.Color := clBtnHighlight
else    Pen.Color := clBtnShadow;
          LineTo(Control.Width-1,Control.Height-1);
          LineTo(0,Control.Height-1);
           
        _prop_DrawFrame:= ToInteger(_data);

Brush.BrushStyle := bsSolid;
          Brush.Color := Control.Color;
          Rectangle(0,0,Control.Width,Control.Height);

          if FBmp.Handle <> 0 then
             FBmp.Draw(Handle,FX,FY); 

          DrawText(Control.Caption, r, DT_EXPANDTABS or DT_SINGLELINE or DT_CENTER or DT_VCENTER);

if _prop_DrawFrame = 0 then
          Pen.Color := clBtnShadow
else    Pen.Color := clBtnHighlight;
          MoveTo(0,Control.Height-1);
          LineTo(0,0);
          LineTo(Control.Width-1,0);
if _prop_DrawFrame = 0 then
          Pen.Color := clBtnHighlight
else    Pen.Color := clBtnShadow;
          LineTo(Control.Width-1,Control.Height-1);
          LineTo(0,Control.Height-1);

Control.Invalidate;
    end;
end;

end.
